# -*- coding: utf-8 -*-
"""
Created on Sun Feb  7 02:00:32 2021

@author: hsamboko
"""

import rasterio
import pandas as pd
import numpy as np
import os
import matplotlib.pyplot as plt
import math
from mpl_toolkits.axes_grid1 import make_axes_locatable
from pandas import DataFrame

def extract_z(fn, xy):
    """
    function to extract values from a raster over a list of xy points
    """


XL =200321.6
YL =8340808.9
XR =200703.6
YR =8340713.5

x = np.linspace(XL, XR, 999, endpoint = True)
y = np.linspace(YL, YR, 999, endpoint = True)
X = pd.DataFrame(x)
Y = pd.DataFrame(y)
XY = pd.concat([X,Y], axis=1, sort=False)
XY.columns = (['X', 'Y'])
#print(XY)

#np.savetxt('list.csv',XY,delimiter = ',')  
dataset = rasterio.open(r'C:\Users\hsamboko\Documents\PHD\Thesis\cloud_compare\noGCP.tif')
dataset1 = rasterio.open(r'C:\Users\hsamboko\Documents\PHD\Thesis\cloud_compare\fcp.tif')
dataset2 = rasterio.open(r'C:\Users\hsamboko\Documents\PHD\Thesis\cloud_compare\brown.tif')
dataset3 = rasterio.open(r'C:\Users\hsamboko\Documents\PHD\Thesis\cloud_compare\5fcp.tif')
dataset4 = rasterio.open(r'C:\Users\hsamboko\Documents\PHD\Thesis\cloud_compare\9fcp.tif')
dataset5 = rasterio.open(r'C:\Users\hsamboko\Documents\PHD\Thesis\cloud_compare\13fcp.tif')
dataset6 = rasterio.open(r'C:\Users\hsamboko\Documents\PHD\Thesis\cloud_compare\17fcp.tif')


track_xy = XY

Z = np.array([x[0] for x in  rasterio.sample.sample_gen(dataset, track_xy.values, indexes=None)])
Z1 = np.array([x[0] for x in  rasterio.sample.sample_gen(dataset1, track_xy.values, indexes=None)])
Z2 = np.array([x[0] for x in  rasterio.sample.sample_gen(dataset2, track_xy.values, indexes=None)])
Z3 = np.array([x[0] for x in  rasterio.sample.sample_gen(dataset3, track_xy.values, indexes=None)])
Z4 = np.array([x[0] for x in  rasterio.sample.sample_gen(dataset4, track_xy.values, indexes=None)])
Z5 = np.array([x[0] for x in  rasterio.sample.sample_gen(dataset5, track_xy.values, indexes=None)])
Z6 = np.array([x[0] for x in  rasterio.sample.sample_gen(dataset6, track_xy.values, indexes=None)])

print(Z.min())
print(Z1.min())
print(Z2.min())
print(Z3.min())
print(Z4.min())
print(Z5.min())
print(Z6.min())


fig, ax = plt.subplots(1, figsize = (20, 10))
plt.setp(ax.get_xticklabels(), fontsize=20)
plt.setp(ax.get_yticklabels(), fontsize=20)
width = np.linspace(0, 540, 999)
plt.ylabel('Z [m]', fontsize=28)
plt.xlabel('Floodplain Width [m]', fontsize=28)
plt.title('Cross Section', fontsize=32)
plt.setp(ax.get_xticklabels(), fontsize=20)
plt.setp(ax.get_yticklabels(), fontsize=20)
plt.rcParams["font.family"] = "Times New Roman"
plt.plot(width, Z,'-p', color='gray',
         markersize=2, linewidth=1,
         markerfacecolor='white',
         markeredgecolor='gray',
         markeredgewidth=2, label='No GCP')
plt.plot(width, Z1,'-o', color='red',
         markersize=2, linewidth=1,
         markerfacecolor='white',
         markeredgecolor='red',
         markeredgewidth=2, label='FCP')
plt.plot(width, Z2, '-o', color='Brown',
         markersize=2, linewidth=2,
         markerfacecolor='white',
         markeredgecolor='brown',
         markeredgewidth=2, label='Brown')
plt.plot(width, Z3, 'blue', markersize=1, label='5 GCPs')
plt.plot(width, Z4, 'green', markersize=1, label='9 GCPs')
plt.plot(width, Z5, 'black', markersize=1, label='13 GCPs')
plt.plot(width, Z6, 'magenta', markersize=1, label='17 GCPs')
ax.legend(loc='best', fontsize = 18)

Depth =  Z - Z1.min()
Depth1 = Z1- Z1.min()
Depth2 = Z2 - Z1.min()
Depth3 = Z3- Z1.min()
Depth4 = Z4 - Z1.min()
Depth5 = Z5 - Z1.min()
Depth6 = Z6- Z1.min()

#print(Depth)
myFile = pd.read_csv(r'C:\Users\hsamboko\Documents\PHD\Thesis\Bathymetry_scripts\crossection scripts\width.csv', sep=',')
increamental_width = ((X-XL)**2  + (Y-YL)**2)**0.5
increamental_width2 = increamental_width.values.flatten()

#print(p1)
#
##plt.plot(increamental_width2,Depth)
#plt.plot(increamental_width2,Depth1)
##plt.plot(increamental_width2,Depth2)
#plt.plot(increamental_width2,Depth3)
#plt.plot(increamental_width2,Depth4)
#plt.plot(increamental_width2,Depth5)
#plt.plot(increamental_width2,Depth6)

def cross_sectional_area(widths, depths, nr_steps_hrange=100, normalize_lowest_point=True):
    """
    Prepare a function to calculate the cross-sectional area from profile information
    inputs:
        widths: pandas DataFrame with width distance from left-side
        depths: pandas DataFrame (equal size as widths) with depths per distance point
        
    """
    depth_min = depths.min()
    if normalize_lowest_point:
        depths -= depth_min
        depth_min = 0.
    
    depth_max = depths.max()
    hrange = np.linspace(depth_min + 0.1, depth_max, nr_steps_hrange)
    width_diff = abs(widths[1:] - widths[:-1])
    depth_mean = (depths[1:] + depths[:-1])/2.
    A = [np.nansum((width_diff * (k + depth_mean))[np.greater(k, depth_mean)]) for k in hrange]
    return A,hrange

[A,hrange] = np.array(cross_sectional_area(increamental_width2, Depth * -1))            
[A1,hrange] = np.array(cross_sectional_area(increamental_width2, Depth1 * -1)) 
[A2,hrange] = np.array(cross_sectional_area(increamental_width2, Depth2 * -1))
[A3,hrange] = np.array(cross_sectional_area(increamental_width2, Depth3 * -1))
[A4,hrange] = np.array(cross_sectional_area(increamental_width2, Depth4 * -1))
[A5,hrange] = np.array(cross_sectional_area(increamental_width2, Depth5 * -1))
[A6,hrange] = np.array(cross_sectional_area(increamental_width2, Depth6 * -1))
#plt.close('all')

fig, ax = plt.subplots(1, figsize = (20, 10))
plt.setp(ax.get_xticklabels(), fontsize=20)
plt.setp(ax.get_yticklabels(), fontsize=20)

ax.plot(A, hrange, '-p', color='gray',
         markersize=6, linewidth=4,
         markerfacecolor='white',
         markeredgecolor='gray',
         markeredgewidth=2, label='No GCPs')  
ax.plot(A1, hrange,'-o', color='red',
         markersize=5, linewidth=3,
         markerfacecolor='white',
         markeredgecolor='red',
         markeredgewidth=2, label='FCP')
ax.plot(A2, hrange, '-o', color='Brown',
         markersize=5, linewidth=3,
         markerfacecolor='white',
         markeredgecolor='brown',
         markeredgewidth=2, label='Brown')  
ax.plot(A3, hrange, 'blue', markersize=3, label='5 GCP')
ax.plot(A4, hrange, 'green', markersize=3, label='9 GCP')
ax.plot(A5, hrange, 'black', markersize=3, label='13 GCP')
ax.plot(A6, hrange, 'magenta', markersize=3, label='17 GCP')               
ax.grid()
ax.set_xlabel('Area [$m^2$]', fontsize=28)
ax.set_ylabel('Depth [m]', fontsize=28)
ax.legend(loc='best', fontsize = 18)
ax.set_title('Area vs Depth ', fontsize=32)

increamental_width = ((X-XL)**2  + (Y-YL)**2)**0.5
increamental_width2 = increamental_width.values.flatten()

def perimeter(widths, depths, nr_steps_hrange=100, normalize_lowest_point=True):
    """
    Function perimeter calculation
    
    """
    depth_min = depths.min()
    if normalize_lowest_point:
        depths -= depth_min
        depth_min = 0.
    depth_max = depths.max()
    hrange = np.linspace(depth_min, depth_max, nr_steps_hrange)
    width_diff = abs(widths[1:] - widths[:-1])
    depth_mean = (depths[1:] + depths[:-1])/2.
    diff_h = depths[1:] - depths[:-1]
    P_diff = np.sqrt((diff_h**2) + (width_diff**2))
    P = [np.nansum(P_diff[np.greater(l, depth_mean)]) for l in hrange]
    return P,hrange

[P,hrange] = np.array(perimeter(increamental_width2, Depth * -1))
P[P == 0]=np.nan
[P1,hrange] = np.array(perimeter(increamental_width2, Depth1 * -1))
[P2,hrange] = np.array(perimeter(increamental_width2, Depth2 * -1))
[P3,hrange] = np.array(perimeter(increamental_width2, Depth3 * -1))
[P4,hrange] = np.array(perimeter(increamental_width2, Depth4 * -1))
[P5,hrange] = np.array(perimeter(increamental_width2, Depth5 * -1))
[P6,hrange] = np.array(perimeter(increamental_width2, Depth6 * -1))
#plt.close('all')

fig, ax = plt.subplots(1, figsize = (20, 10))
plt.setp(ax.get_xticklabels(), fontsize=20)
plt.setp(ax.get_yticklabels(), fontsize=20)         
ax.plot(A, P, '-p', color='gray',
         markersize=6, linewidth=4,
         markerfacecolor='white',
         markeredgecolor='gray',
         markeredgewidth=2, label='No GCPs')
ax.plot(A1, P1, '-o', color='red',
         markersize=5, linewidth=3,
         markerfacecolor='white',
         markeredgecolor='red',
         markeredgewidth=2, label='FCP')
ax.plot(A2, P2,'-o', color='brown',
         markersize=5, linewidth=3,
         markerfacecolor='white',
         markeredgecolor='brown',
         markeredgewidth=2, label='Brown')
ax.plot(A3, P3, 'blue', markersize=3, label='5 GCPs')
ax.plot(A4, P4, 'green', markersize=3, label='9 GCPs')
ax.plot(A5, P5, 'black', markersize=3, label='13 GCPs')
ax.plot(A6, P6, 'magenta', markersize=3, label='17 GCPs')
ax.set_xlabel('Area [$m^2$]', fontsize=28)
ax.set_ylabel('Perimeter [m]', fontsize=28) 
ax.legend(loc='best', fontsize = 20)
ax.grid()
ax.set_title('Area vs Perimeter ',fontsize=32)
#fig.savefig('27042018_area_perimeter_all.png', bbox_inches='tight')

def conveyance(area, perimeter):
    """
    calculate conveyance
    
    """
    R = area/perimeter
    C = area * (R**(2./3.))
    return R, C



R, C = conveyance(A, P)
R1, C1 = conveyance(A1, P1)
R2, C2 = conveyance(A2, P2)
R3, C3 = conveyance(A3, P3)
R4, C4 = conveyance(A4, P4)
R5, C5 = conveyance(A5, P5)
R6, C6 = conveyance(A6, P6)
fig, ax = plt.subplots(1, figsize = (20, 10))
plt.setp(ax.get_xticklabels(), fontsize=20)
plt.setp(ax.get_yticklabels(), fontsize=20)
ax.plot(hrange,C,  '-o', color='gray',
         markersize=5, linewidth=4,
         markerfacecolor='white',
         markeredgecolor='white',
         markeredgewidth=2, label='No GCPs')
ax.plot(hrange, C1, '-o', color='red',
         markersize=5, linewidth=4,
         markerfacecolor='white',
         markeredgecolor='red',
         markeredgewidth=2, label='FCP')
ax.plot(hrange, C2, 'brown',markersize=3, label='Brown')
ax.plot( hrange,C3, 'blue', markersize=3, label='5 GCPs')
ax.plot(hrange, C4, 'green', markersize=3, label='9 GCPs')
ax.plot(hrange, C5, 'black', markersize=3, label='13 GCPs')
ax.plot(hrange, C6, 'magenta', markersize=3, label='17 GCPs')
plt.xlim(0,7)
plt.ylim(0,1000)
ax.legend(loc='best', fontsize = 20)
ax.set_xlabel('Depth [m]', fontsize=28)
ax.set_ylabel('Conveyance = $AR^{2/3}$ [$m^{8/3}$]',fontsize=28)
ax.set_title('Conveyance vs Depth ', fontsize=32)